//	 GetPass 7.1 - C_FILTER for F6FBB BBS Software
//  Written by Marco Savegnago IW3FQG

#ifndef __GPMD2_H
#define __GPMD2_H

/*

   MD2 C++ Class type prototype

   27/10/1992 Marco Savegnago


   RSA Data Security, Inc., MD2 message-digest algorithm
   Copyright (C) 1990-2, RSA Data Security, Inc. Created 1990. All
   rights reserved.

   License to copy and use this software is granted for
   non-commercial Internet Privacy-Enhanced Mail provided that it is
   identified as the "RSA Data Security, Inc. MD2 Message Digest
   Algorithm" in all material mentioning or referencing this software
   or this function.

   RSA Data Security, Inc. makes no representations concerning either
   the merchantability of this software or the suitability of this
   software for any particular purpose. It is provided "as is"
   without express or implied warranty of any kind.

   These notices must be retained in any copies of any part of this
   documentation and/or software.
*/

class MD2
{
	unsigned int ui_count;					// number of bytes, modulo 16
	unsigned char by_state[16];             // state
	unsigned char by_checksum[16];          // by_checksum
	unsigned char by_buffer[16];            // input buffer
	unsigned char by_digest[16];            // output buffer
	unsigned char by_digestString[33];		// output string

	void transform(unsigned char *block);


public:

	MD2();
	MD2(char *string);
	void init();
	void update(unsigned char *input, unsigned int inputLen );
	void final();
	unsigned char*	getDigest();
	char*			getString();
	void 			setString(char *str);
	int 			sizeofDigest();

};

inline MD2::MD2()
{
	init();
}

inline unsigned char*	MD2::getDigest()
{
	return by_digest;
}

inline int MD2::sizeofDigest()
{
	return sizeof(by_digest);
}
#endif // __GPMD2_H
